
#include "process.h"
#include "console.h"
#include "segment.h"

tss_struct *init_tss;
process_stack *init_stack;
process_table *init_pcb;

unsigned int reg;
	

void init(void)
{
	char *bp = (char *)0xb8000;
	int a=0;
	a = 100;
	*bp = 'X';
	while(1) (*bp)++;
}

void init_process(void)
{
	int l;

	//
	// read pointer of TSS from 0x9000, somewhere over 0x9XXX
	//
	unsigned int tmp = *(unsigned int *)TSS_WHERE;
	char *src, *dst;

	// kernel mode stack & process table
	init_stack = (process_stack *)0x40001000;
	init_pcb = (process_table *)init_stack;

	// TSS for CPU
	init_tss = (tss_struct *)tmp;


	caos_printf("CPU TSS is at->%x\n", 
					(unsigned int)init_tss, (unsigned int)init_pcb);

	// Kernel Stack segment = 0x10
	init_tss->ss0 = 0x10;

	// copy init function at 0x4000 0000
	caos_printf("Copy init function at 0x4000 0000\n");
	src = (char *)init;
	dst = (char *)0x40000000;

	for (l=0; l < 1024; l++)
		*dst++ = *src++;

	// setup PCB of init process
	init_pcb->thread.eip = (unsigned int)0x40000000;
	init_pcb->thread.esp = (unsigned int)0x40000fff;
	init_pcb->thread.esp0 = (unsigned int)0x4001fff;
	init_pcb->thread.cs = __USER_CS;
	init_pcb->thread.eflags = 0x200;// set only interrupt flag
	init_pcb->thread.ss = __USER_DS;
	init_pcb->thread.ds = __USER_DS;
	init_pcb->thread.es = __USER_DS;
	init_pcb->thread.fs = __USER_DS;
	init_pcb->thread.gs = __USER_DS;

}



void start_init(void)
{	
	reg = (unsigned int)&(init_pcb->thread);

	asm volatile (
		"cli							\n\t"
		/* 
		 * Before load TR, TSS must be initialized.
		 * Therefore kernel stack pointer is store at init_tss->esp0.
		 */ 
		"mov %%esp, %0		\n\t"
		/* load TR with TSS selector */
		"mov $0x20, %%ax	\n\t"
		"ltr %%ax					\n\t"
		"mov %1, %%esp		\n\t"
		"popa							\n\t"
		"pop %%ds				\n\t"
		"pop %%es				\n\t"
		"pop %%fs				\n\t"
		"pop %%gs				\n\t"
		"sti						\n\t"
		"iret						\n\t"
		: "=m"(init_tss->esp0)
		: "m"(reg)
	);
}
		

